<?php
error_reporting(-1);

class Qb
{
	private static
		$_language = 'English',
		$_translations = array('English' => array());

	public static function setLanguage($language)
	{
		$old = self::$_language;
		if ($language != $old) {
			// Use the same translations for new language
			$domainNames = array_keys(self::$_translations[$old]);
			self::$_language = $language;
			foreach ($domainNames as $domainName) {
				self::useTranslation($domainName);
			}
		}
		return $old;
	}

	public static function useTranslation($domainName)
	{
		$domains =& self::$_translations[self::$_language];
		if (!isset($domains[$domainName])) {
			echo '***debug: load ' . self::$_language . '/' . $domainName . "<br/>\n";
			$file = 'lang/' . self::$_language . '/' . $domainName . '.ser';
			$domains[$domainName] = unserialize(file_get_contents($file));
		}
	}

	public static function t($key, $domainName = 'common')
	{
		return self::$_translations[self::$_language][$domainName][$key];
	}
}

header('Content-type: text/html; charset=utf-8');

echo '***debug: Initial load' . "<br/>\n";
Qb::setLanguage('Russian');
Qb::useTranslation('common');
Qb::useTranslation('topic');

// Output on Russian
echo '***debug: Output on Russian' . "<br/>\n";
echo Qb::t('New posts') . "<br/>\n";
echo Qb::t('Post reply', 'topic') . "<br/>\n";

$old = Qb::setLanguage('English');
echo '***debug: Output on English' . "<br/>\n";
echo Qb::t('New posts') . "<br/>\n";
echo Qb::t('Post reply', 'topic') . "<br/>\n";

Qb::setLanguage($old);
echo '***debug: Output on Russian' . "<br/>\n";
echo Qb::t('New posts') . "<br/>\n";
echo Qb::t('Post reply', 'topic') . "<br/>\n";
